/* tslint:disable */
/* eslint-disable */
/**
* @returns {Uint8Array}
*/
export function webassembly_x25519_generate_key_pair(): Uint8Array;
/**
* @param {Uint8Array} plaintext
* @param {Uint8Array} public_key
* @param {Uint8Array} authenticated_data
* @returns {Uint8Array}
*/
export function webassembly_ecies_salsa_seal_box_encrypt(plaintext: Uint8Array, public_key: Uint8Array, authenticated_data: Uint8Array): Uint8Array;
/**
* @param {Uint8Array} ciphertext
* @param {Uint8Array} private_key
* @param {Uint8Array} authenticated_data
* @returns {Uint8Array}
*/
export function webassembly_ecies_salsa_seal_box_decrypt(ciphertext: Uint8Array, private_key: Uint8Array, authenticated_data: Uint8Array): Uint8Array;

export type InitInput = RequestInfo | URL | Response | BufferSource | WebAssembly.Module;

export interface InitOutput {
  readonly memory: WebAssembly.Memory;
  readonly webassembly_x25519_generate_key_pair: (a: number) => void;
  readonly webassembly_ecies_salsa_seal_box_encrypt: (a: number, b: number, c: number, d: number, e: number, f: number, g: number) => void;
  readonly webassembly_ecies_salsa_seal_box_decrypt: (a: number, b: number, c: number, d: number, e: number, f: number, g: number) => void;
  readonly __wbindgen_add_to_stack_pointer: (a: number) => number;
  readonly __wbindgen_export_0: (a: number, b: number) => number;
  readonly __wbindgen_export_1: (a: number) => void;
}

export type SyncInitInput = BufferSource | WebAssembly.Module;
/**
* Instantiates the given `module`, which can either be bytes or
* a precompiled `WebAssembly.Module`.
*
* @param {SyncInitInput} module
*
* @returns {InitOutput}
*/
export function initSync(module: SyncInitInput): InitOutput;

/**
* If `module_or_path` is {RequestInfo} or {URL}, makes a request and
* for everything else, calls `WebAssembly.instantiate` directly.
*
* @param {InitInput | Promise<InitInput>} module_or_path
*
* @returns {Promise<InitOutput>}
*/
export default function __wbg_init (module_or_path?: InitInput | Promise<InitInput>): Promise<InitOutput>;
